#ifndef INITUI_H
#define INITUI_H

#define HELPSTRING	"VREng usage : \n\
   -world URLcfg	URL of the world\n\
   -nick nickname	Your nickname\n\
   -skinf URLgif	URL of your front skin\n\
   -skinb URLgif	URL of your back skin\n
   -mc group/port/ttl	Multicast address of the world\n\
   -width3D width	Width of the 3D window\n\
   -height3D height	Height of the 3D window\n\
   -quality n		3D quality (0=normal, 1=high)\n\
			The high quality should be selected if\n\
			you have a 3D card.\n\
   -history size	Number of lines in the text history\n\
   -V			Version number\n\
   --version		Version number ala GNU\n\
   -d level		Debugging level\n"

#define XtNwidth3D	"width3D"
#define XtCWidth3D	"Width3D"
#define XtNheight3D	"height3D"
#define XtCHeight3D	"Height3D"
#define XtNmaxsimcon	"maxsimcon"
#define XtCMaxSimCon	"MaxSimCon"
#define XtNdebug	"debug"
#define XtCDebug	"Debug"
#define XtNversion	"version"
#define XtCVersion	"Version"
#define XtNhistlength	"histlength"
#define XtCHistLength	"HistLength"
#define XtNquality	"quality"
#define XtCQuality	"Quality"
#define XtNmulticast	"multicast"
#define XtCMulticast	"Multicast"
#define XtNnick		"nick"
#define XtCNick		"Nick"
#define XtNworld	"world"
#define XtCWorld	"World"
#define XtNskinf	"skinf"
#define XtCSkinf	"Skinf"
#define XtNskinb	"skinb"
#define XtCSkinb	"Skinb"


typedef struct vreng_resources {
  int width3D;
  int height3D;
  int maxsimcon;
  int debug;
  int histlength;
  int quality;
  char *multicast;
  char *nick;
  char *libpath;
  char *world;
  char *skinf;
  char *skinb;
  char *version;
} VRengResources;

/* variables */
extern VRengResources resources;	/* Resources du programme */
extern XtAppContext appContext;		/* Application Context */
extern int width3D, height3D;		/* largeur de le reprsentation 3D */
extern Widget threeDWidget;		/* La widget 3D */
extern Widget displayText;		/* La widget qui affiche cette chane */
extern Widget statusLabel;		/* Widget to display  Warnings */
extern Widget topLevel,panedH,panedV,panedVB,panedMenu,enterText;
extern Widget labelSep,labelLeft,labelPlayer; /* labels on the left column */
extern int gl_quality;			/* display quality */
extern char *displaystring;		/* string displayed by displayText */

/* functions */
extern void initResources(int, char**);
extern void initPaned();


#endif /* INITUI_H */
